<?php

class Simple_Slider_Admin extends Simple_Slider {
	/**
	 * Error messages to diplay
	 *
	 * @var array
	 */
	private $_messages = array();
	
	
	/**
	 * Class constructor
	 *
	 */
	public function __construct() {
		$this->_plugin_dir   = DIRECTORY_SEPARATOR . str_replace(basename(__FILE__), null, plugin_basename(__FILE__));
		$this->_settings_url = 'options-general.php?page=' . plugin_basename(__FILE__);
		
		$allowed_options = array(
			
		);
		
		// set watermark options
		if(array_key_exists('option_name', $_GET) && array_key_exists('option_value', $_GET)
			&& in_array($_GET['option_name'], $allowed_options)) {
			update_option($_GET['option_name'], $_GET['option_value']);
			
			header("Location: " . $this->_settings_url);
			die();	
			
		} else {
			// register installer function
			register_activation_hook(SS_LOADER, array(&$this, 'activateSimpleSlider'));
		
			// add plugin "Settings" action on plugin list
			add_action('plugin_action_links_' . plugin_basename(SS_LOADER), array(&$this, 'add_plugin_actions'));
			
			// add links for plugin help, donations,...
			add_filter('plugin_row_meta', array(&$this, 'add_plugin_links'), 10, 2);
			
			// push options page link, when generating admin menu
			add_action('admin_menu', array(&$this, 'adminMenu'));
	
			
		}
		
		add_action( 'wp_enqueue_scripts', array(&$this, 'loadScripts'));

	}
	
	/**
	 * Add "Settings" action on installed plugin list
	 */
	public function add_plugin_actions($links) {
		array_unshift($links, '<a href="options-general.php?page=' . plugin_basename(__FILE__) . '">' . __('Settings') . '</a>');
		
		return $links;
	}
	
	/**
	 * Add links on installed plugin list
	 */
	public function add_plugin_links($links, $file) {
		if($file == plugin_basename(SS_LOADER)) {
			$links[] = '<a href="http://MyWebsiteAdvisor.com/">Visit Us Online</a>';
		}
		
		return $links;
	}
	
	/**
	 * Add menu entry for Simple Slider settings 
	 */
	public function adminMenu() {		
		// add option in admin menu,
		$plugin_page = add_options_page('Simple Slider Plugin Options', 'Simple Slider', 8, __FILE__, array(&$this, 'optionsPage'));

		add_action('admin_print_styles-' . $plugin_page, array(&$this, 'installStyles'));
		add_action('admin_print_scripts-' . $plugin_page, array(&$this, 'loadScripts'));
	}
	
	/**
	 * Include styles used by Plugin
	 */
	public function installStyles() {
		//wp_enqueue_style('simple-slider', WP_PLUGIN_URL . $this->_plugin_dir . 'style.css');
	}
	

	public function loadScripts(){
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-sortable');
		wp_enqueue_script('j-cycle', WP_PLUGIN_URL . $this->_plugin_dir . '/js/jquery.cycle.all.js', array('jquery'), '', false);
		wp_enqueue_script('j-easing', WP_PLUGIN_URL . $this->_plugin_dir . '/js/jquery.easing.1.3.js', array('jquery'), '', false);
		wp_enqueue_script('cufon-yui', WP_PLUGIN_URL . $this->_plugin_dir . 'cufon/cufon-yui.js', '', '', false);
    	wp_enqueue_script('cufon-font', WP_PLUGIN_URL . $this->_plugin_dir . 'cufon/fonts/impact_400.font.js', '', '', false);
			
	}


	function HtmlPrintBoxHeader($id, $title, $right = false) {
		
		?>
		<div id="<?php echo $id; ?>" class="postbox">
			<h3 class="hndle"><span><?php echo $title ?></span></h3>
			<div class="inside">
		<?php
		
		
	}
	
	function HtmlPrintBoxFooter( $right = false) {
		?>
			</div>
		</div>
		<?php
		
	}
	

	
	public function build_slider(){
	
		$simple_slider = get_option('simple_slider');
		$ss_config = $simple_slider['slideshow_config'];
		$ss_options = $simple_slider['plugin_config'];
		
		$output = "<script>
	
				jQuery(document).ready(function($) {
				
					Cufon.replace('#slider_holder h2, #slider_holder #aio-nav');
				
					jQuery('#slider_holder ul').cycle({ 
						fx: '" . $ss_options['slider_effect']. "',
						timeout: ". $ss_options['slider_timeout'] * 1000 .",
						speed: ".  $ss_options['slider_speed'] * 1000 .",
						pause: 1,
						fit: 1,
						next:   '#next',
						prev:   '#prev',
						pager:  '#aio-nav'
					});
				
    
					jQuery('#slider_holder').hover(function() { 
						//mouse in	
						jQuery('#slider_holder #prevnext').fadeIn('slow');             
					}, function() { 
						//mouse out
						jQuery('#slider_holder #prevnext').fadeOut('slow');	
					});
					
				});
				
				</script>";
				
				
		$output .= "<style type='text/css' media='screen'>
		.entry-content img, .comment-content img, .widget img{
			max-width:100% !important;
		}";	
		
		/*slider*/
		$output .= "
			#slider_holder {
				position: relative;
				width: ".$ss_options['width']."px;
				height: ".$ss_options['height']."px;
				margin: 0; padding: 0;
				overflow: hidden;
			}
			
			#slider_holder ul {	
				margin: 0 !important; padding: 0 !important;		
			}
			
			#slider_holder ul li {
				position: relative;
				width: ".$ss_options['width']."px;
				height: ".$ss_options['height']."px;
				margin: 0; padding: 0;
				overflow: hidden;
			}
			
			#slider_holder ul li .text-bg {
				position: absolute;
				min-width: 80%;
				min-height: 20px;
				left: 0;
				bottom: 5%;
				padding: 5px 10px 5px 10px;
				text-align: left;
				background: #ffffff;
				opacity: 0.7;
			}
			
			#slider_holder ul li .text-bg h2 {
				position: relative;        
				margin: 0 0 0 0px;        
				font-size: 24px;
				line-height: 1;
				color: #000;
				opacity: 1.0 !important;
			}  
			
			#slider_holder ul li .text-bg h2:hover {
				
				color: #ff0000;
				
			}    
			
			#slider_holder ul li .text-bg h2 .cufon.cufon-canvas cufontext {
			   opacity: 1.0 !important;
			}";
			
	
		/*previous/next*/
		$output .= " 
	   #slider_holder #prevnext {
			position: absolute;
			width: ".$ss_options['width']."px;
			height: 48px;
			top: ".($ss_options['height']/2-24)."px;
			text-indent: -9999px;
			left: 0px;
			z-index: 9999999;  
		}
		
		#slider_holder #prevnext.hidden {
			z-index: -999999;
			opacity: 1 !important;
		}
		
		#slider_holder #prevnext a { position: absolute; display: block; width: 38px; height: 48px; outline: none; border: none;  }
	
		#slider_holder #prevnext a#prev { left: 0px; background: url(". WP_CONTENT_URL ."/plugins/simple-slider/images/left.png) no-repeat; }
		
		#slider_holder #prevnext a#next { right: 0px; background: url(". WP_CONTENT_URL ."/plugins/simple-slider/images/right.png) no-repeat; }";
				
		$output .= "</style>";		
				
		
		$nl = "\n"; 
		
		$output .= '<div id="slider_holder">'.$nl;
		
		$output .= '<ul>'.$newline;
		
		foreach($ss_config as $data) {
			if($data['img_url'] !== ''){
				$output .= '<li>';
			   
				if($data['link_url']){
					$output .= '<a href="'.$data['link_url'].'">';
				}
				
				$output .= '<img src="'.$data['img_url'].'" width="'. $ss_options['width'] .'" height="'. $ss_options['height'] .'"  class="'.$data['id'].'" alt="'.$data['img_title'].'" title="'.$data['img_title'].'"  />';
				
				if( $data['img_text'] ){
					$output .= '<div class="text-bg">';
					$output .= '<h2>';        
					$output .= $data['img_text'];     
					$output .= '</h2>';
					$output .= '</div>';
				}
				
				if($data['link_url'])
				$output .= '</a>';
				
				$output .= '</li>';
				
				$output .= $nl;
			}
		}
		
		$output .= '</ul>'.$nl;
		$output .= '<div id="prevnext"><a id="prev" href="#prevslide">Prev</a> <a id="next" href="#nextslide">Next</a></div>';
		$output .= '</div>'.$nl;  
		
		return $output;  
	}
	
	


	
	/**
	 * Display options page
	 */
	public function optionsPage() {
		// if user clicked "Save Changes" save them
		if(isset($_POST['Submit'])) {
			foreach($this->_options as $option => $value) {
				if(array_key_exists($option, $_POST)) {
					update_option($option, $_POST[$option]);
				} else {
					update_option($option, $value);
				}
			}
			
			
			

			$this->_messages['updated'][] = 'Options updated!';
		}


		
		
	
		foreach($this->_messages as $namespace => $messages) {
			foreach($messages as $message) {
?>
<div class="<?php echo $namespace; ?>">
	<p>
		<strong><?php echo $message; ?></strong>
	</p>
</div>
<?php
			}
		}
		
		
			
			
				
?>

	
									  
<script type="text/javascript">var wpurl = "<?php bloginfo('wpurl'); ?>";</script>

<style>

.fb_edge_widget_with_comment {
	position: absolute;
	top: 0px;
	right: 200px;
}

</style>

<div  style="height:20px; vertical-align:top; width:50%; float:right; text-align:right; margin-top:5px; padding-right:16px; position:relative;">

	<div id="fb-root"></div>
	<script>(function(d, s, id) {
	  var js, fjs = d.getElementsByTagName(s)[0];
	  if (d.getElementById(id)) return;
	  js = d.createElement(s); js.id = id;
	  js.src = "//connect.facebook.net/en_US/all.js#xfbml=1&appId=253053091425708";
	  fjs.parentNode.insertBefore(js, fjs);
	}(document, 'script', 'facebook-jssdk'));</script>
	
	<div class="fb-like" data-href="http://www.facebook.com/MyWebsiteAdvisor" data-send="true" data-layout="button_count" data-width="450" data-show-faces="false"></div>
	
	
	<a href="https://twitter.com/MWebsiteAdvisor" class="twitter-follow-button" data-show-count="false"  >Follow @MWebsiteAdvisor</a>
	<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>


</div>

<div class="wrap" id="sm_div">

	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>Simple Backup Plugin Settings</h2>
	
		
		
	<div id="poststuff" class="metabox-holder has-right-sidebar">
		<div class="inner-sidebar">
			<div id="side-sortables" class="meta-box-sortabless ui-sortable" style="position:relative;">
			
<?php $this->HtmlPrintBoxHeader('pl_diag',__('Plugin Diagnostic Check','diagnostic'),true); ?>

				<?php
				
				echo "<p>Server OS: ".PHP_OS."</p>";
				
				echo "<p>Required PHP Version: 5.0+<br>";
				echo "Current PHP Version: " . phpversion() . "</p>";
			
				echo "<p>Memory Use: " . number_format(memory_get_usage()/1024/1024, 1) . " / " . ini_get('memory_limit') . "</p>";
				
				echo "<p>Peak Memory Use: " . number_format(memory_get_peak_usage()/1024/1024, 1) . " / " . ini_get('memory_limit') . "</p>";
				
				$lav = sys_getloadavg();
				echo "<p>Server Load Average: ".$lav[0].", ".$lav[1].", ".$lav[2]."</p>";
				
				?>

<?php $this->HtmlPrintBoxFooter(true); ?>



<?php $this->HtmlPrintBoxHeader('pl_resources',__('Plugin Resources','resources'),true); ?>

	<p><a href='http://mywebsiteadvisor.com/wordpress-plugins/simple-slider/' target='_blank'>Plugin Homepage</a></p>
	<p><a href='http://mywebsiteadvisor.com/contact-us/'  target='_blank'>Plugin Support</a></p>
	<p><a href='http://mywebsiteadvisor.com/contact-us/'  target='_blank'>Suggest a Feature</a></p>
	
<?php $this->HtmlPrintBoxFooter(true); ?>




<?php $this->HtmlPrintBoxHeader('more_plugins',__('More Plugins','more_plugins'),true); ?>
	
	<p><a href='http://mywebsiteadvisor.com/tools/premium-wordpress-plugins/'  target='_blank'>Premium WordPress Plugins!</a></p>
	<p><a href='http://profiles.wordpress.org/MyWebsiteAdvisor/'  target='_blank'>Free Plugins on Wordpress.org!</a></p>
	<p><a href='http://mywebsiteadvisor.com/tools/wordpress-plugins/'  target='_blank'>Free Plugins on Our Website!</a></p>	
				
<?php $this->HtmlPrintBoxFooter(true); ?>


<?php $this->HtmlPrintBoxHeader('follow',__('Follow MyWebsiteAdvisor','follow'),true); ?>

	<p><a href='http://facebook.com/MyWebsiteAdvisor/'  target='_blank'>Follow us on Facebook!</a></p>
	<p><a href='http://twitter.com/MWebsiteAdvisor/'  target='_blank'>Follow us on Twitter!</a></p>
	<p><a href='http://www.youtube.com/mywebsiteadvisor'  target='_blank'>Watch us on YouTube!</a></p>
	<p><a href='http://MyWebsiteAdvisor.com/'  target='_blank'>Visit our Website!</a></p>	
	
<?php $this->HtmlPrintBoxFooter(true); ?>


</div>
</div>



	<div class="has-sidebar sm-padded" >			
		<div id="post-body-content" class="has-sidebar-content">
			<div class="meta-box-sortabless">
	
			
	
			<form method='post'>
	
			<?php $this->HtmlPrintBoxHeader('config',__('Simple Slider Plugin Configuration','slider-config'),false); ?>	
			
			<div style="float:right; width:40%;">
			<b>Front End Plugin Useage:</b><br />
			
			<p>Plugin Shortcode: (use this on a post or page) <br />
			<pre>[simple_slider]</pre></p>
			
			<p>Template Tag: (use this in a template)<br />
			<pre>&lt;?php echo do_shortcode('[simple_slider]'); ?></pre></p>
			
			</div>
			
				<?php 
					$simple_slider = $this->get_option('simple_slider'); 
					$ss_config = $simple_slider['slideshow_config'];
					$ss_options = $simple_slider['plugin_config'];
					
					$fx_list = array(
						'blindX',
						'blindY',
						'blindZ',
						'cover',
						'curtainX',
						'curtainY',
						'fade',
						'fadeZoom',
						'growX',
						'growY',
						'scrollUp',
						'scrollDown',
						'scrollLeft',
						'scrollRight',
						'scrollHorz',
						'scrollVert',
						'shuffle',
						'slideX',
						'slideY',
						'toss',
						'turnUp',
						'turnDown',
						'turnLeft',
						'turnRight',
						'uncover',
						'wipe',
						'zoom'
					);
					
				?>
			
				
					
					Slideshow Width: <input  type='text' name='simple_slider[plugin_config][width]'  value='<?php echo $ss_options['width']; ?>' /> (px)<br />
					
					Slideshow Height: <input type='text' name='simple_slider[plugin_config][height]' value='<?php echo $ss_options['height']; ?>' /> (px)<br />

					Slideshow Timeout: <input  type='text' name='simple_slider[plugin_config][slider_timeout]'  value='<?php echo $ss_options['slider_timeout']; ?>' /> (sec)<br />
					
					Slideshow Speed: <input type='text' name='simple_slider[plugin_config][slider_speed]' value='<?php echo $ss_options['slider_speed']; ?>' /> (sec)<br />
					
					Slideshow Effect: 
					
					<select name = 'simple_slider[plugin_config][slider_effect]'>
						<option value=''>Select An Effect...</option>
						<?php
						foreach($fx_list as $fx){
						
							$selected = ($fx == $ss_options['slider_effect']) ? "selected='selected'" : "";
							echo "<option value='$fx' $selected>$fx</option>";
						
						}
						?>
						
					</select>
					
					<br />
					
					<input type="submit" name='Submit' value='Save Settings' />
				
			
			
			<?php $this->HtmlPrintBoxFooter(false); ?>
			
			
			
	
	
			<?php $this->HtmlPrintBoxHeader('config',__('Slideshow Configuration','slider-config'),false); ?>	
			
			
			
					<p><b>Drag and Drop Slides to change the order of the slideshow! (Don't forget to save!) </b> </p>
					<input type="submit" name='Submit' value='Save Settings' /><br />
					<br />
					
					<?php
						
						$i = 0;
						
						global $wpdb;
						
						if(count($ss_config) > 0){
							echo "<div id='slider-items-box' class='slider-items-box'>";
							foreach($ss_config as $slider){
								
								if($slider['img_url'] != ""){
									$this->HtmlPrintBoxHeader('config',__("Slide #".($i+1).": ".$slider['img_title'],'slider-config'),false);
									echo "<div class='slider-item' style='cursor:move;'>";
									
									
									$query = "SELECT ID FROM {$wpdb->posts} WHERE guid='".$slider['img_url']."'";
									$attachment_id = $wpdb->get_var($query);
									$attachment_info =  wp_get_attachment_metadata($attachment_id);
									
									$url_info = parse_url($slider['img_url']);
										
									$path_base = pathinfo($url_info['path']);
										
									$file = $url_info['scheme']."://".$url_info['host'].$path_base['dirname']."/".$attachment_info['sizes']['thumbnail']['file'];
									echo "<img src='$file' style='float:right;'>";
									
									
									if($attachment_info){
										echo "<p>Image URL: <input size='100' type='text' name='simple_slider[slideshow_config][$i][img_url]' value='".$slider['img_url']."'></p>";
										
										$selected = ($slider['img_size'] == "Full Size") ? "selected='selected'" : "";
										echo "<p>Image Size: <select name='simple_slider[slideshow_config][$i][img_size]' value='".$slider['img_size']."'  $selected>";
										
										echo "<option value='Full Size'>Full Size (".$attachment_info['width']."x".$attachment_info['height'].")</option>";
										
										 
										
										foreach($attachment_info['sizes'] as $size => $details){
											//$file = $url_info['scheme']."://".$url_info['host'].$path_base['dirname']."/".$details['file'];
											$selected = ($size == $slider['img_size']) ? "selected='selected'" : "";
											echo "<option value='$size' $selected>".ucfirst($size)." (".$details['width']."x".$details['height'].")</option>";
										}
										
										echo "</select>";
										
										echo "</p>";
										
									}else{
										echo "<p>Image URL: <input size='100' type='text' name='simple_slider[slideshow_config][$i][img_url]' value='".$slider['img_url']."'></p>";
									}
									
									echo "<p>Title: <input size='40' type='text' name='simple_slider[slideshow_config][$i][img_title]' value='".$slider['img_title']."'> ";
									echo " Text: <input size='40' type='text' name='simple_slider[slideshow_config][$i][img_text]' value='".$slider['img_text']."'></p>";
									echo "<p>Link URL: <input size='100' type='text' name='simple_slider[slideshow_config][$i][link_url]' value='".$slider['link_url']."'></p>";
									echo "<br>";
									
									echo "</div>";
									$this->HtmlPrintBoxFooter(false);
									$i++;
								}		
							}
							echo "</div>";
						}else{
							echo "No Sliders Defined!<br>";
						}			
				
					
					?>
					
					<br />
					<p><b>Add A Slide to the Slideshow</b></p>
					New Image URL: <input type='text' size='100' name='simple_slider[slideshow_config][<?php echo $i; ?>][img_url]' /><br />
		
					<input type="submit" name='Submit' value='Save Settings' />
				
				
			
			
			
				<script>
				jQuery(document).ready(function($) {
  
  					$('#slider-items-box').sortable({
						
					});
  
  				});
				</script>
				
				
			<?php $this->HtmlPrintBoxFooter(false); ?>
			
			
			</form>
			
			
			
			<?php $this->HtmlPrintBoxHeader('preview',__('Simple Slider Preview','slider-preview'),false); ?>	
			
				<?php echo $this->build_slider(); ?>
	
			<?php $this->HtmlPrintBoxFooter(false); ?>
			
			
			
			
			
			<?php $this->HtmlPrintBoxHeader('preview',__('Simple Slider Preview','slider-preview'),false); ?>
			
				<pre>
				<?php var_dump( $this->get_option('simple_slider') ); ?>
				</pre>
			
			<?php $this->HtmlPrintBoxFooter(false); ?>
			
		
</div></div></div></div>

</div>


<?php
	}
	
}

?>